#! /usr/bin/ruby

require "helper"

class TC_Element < Test::Unit::TestCase
  ELEM = CrystalCell::Element

  def setup
    @e = CrystalCell::Element.new
  end

  include

  def test_atomicNumber
    assert_equal(  1, ELEM.symbol_to_num( 'H'  ))
    assert_equal(  2, ELEM.symbol_to_num( 'He' ))
    assert_equal(  3, ELEM.symbol_to_num( 'Li' ))
    assert_equal(  4, ELEM.symbol_to_num( 'Be' ))
    assert_equal(  5, ELEM.symbol_to_num( 'B'  ))
    assert_equal(  6, ELEM.symbol_to_num( 'C'  ))
    assert_equal(  7, ELEM.symbol_to_num( 'N'  ))
    assert_equal(  8, ELEM.symbol_to_num( 'O'  ))
    assert_equal(  9, ELEM.symbol_to_num( 'F'  ))
    assert_equal( 10, ELEM.symbol_to_num( 'Ne' ))
    assert_equal( 11, ELEM.symbol_to_num( 'Na' ))
    assert_equal( 12, ELEM.symbol_to_num( 'Mg' ))
    assert_equal( 13, ELEM.symbol_to_num( 'Al' ))
    assert_equal( 14, ELEM.symbol_to_num( 'Si' ))
    assert_equal( 15, ELEM.symbol_to_num( 'P'  ))
    assert_equal( 16, ELEM.symbol_to_num( 'S'  ))
    assert_equal( 17, ELEM.symbol_to_num( 'Cl' ))
    assert_equal( 18, ELEM.symbol_to_num( 'Ar' ))
    assert_equal( 19, ELEM.symbol_to_num( 'K'  ))
    assert_equal( 20, ELEM.symbol_to_num( 'Ca' ))
    assert_equal( 21, ELEM.symbol_to_num( 'Sc' ))
    assert_equal( 22, ELEM.symbol_to_num( 'Ti' ))
    assert_equal( 23, ELEM.symbol_to_num( 'V'  ))
    assert_equal( 24, ELEM.symbol_to_num( 'Cr' ))
    assert_equal( 25, ELEM.symbol_to_num( 'Mn' ))
    assert_equal( 26, ELEM.symbol_to_num( 'Fe' ))
    assert_equal( 27, ELEM.symbol_to_num( 'Co' ))
    assert_equal( 28, ELEM.symbol_to_num( 'Ni' ))
    assert_equal( 29, ELEM.symbol_to_num( 'Cu' ))
    assert_equal( 30, ELEM.symbol_to_num( 'Zn' ))
    assert_equal( 31, ELEM.symbol_to_num( 'Ga' ))
    assert_equal( 32, ELEM.symbol_to_num( 'Ge' ))
    assert_equal( 33, ELEM.symbol_to_num( 'As' ))
    assert_equal( 34, ELEM.symbol_to_num( 'Se' ))
    assert_equal( 35, ELEM.symbol_to_num( 'Br' ))
    assert_equal( 36, ELEM.symbol_to_num( 'Kr' ))
    assert_equal( 37, ELEM.symbol_to_num( 'Rb' ))
    assert_equal( 38, ELEM.symbol_to_num( 'Sr' ))
    assert_equal( 39, ELEM.symbol_to_num( 'Y'  ))
    assert_equal( 40, ELEM.symbol_to_num( 'Zr' ))
    assert_equal( 41, ELEM.symbol_to_num( 'Nb' ))
    assert_equal( 42, ELEM.symbol_to_num( 'Mo' ))
    assert_equal( 43, ELEM.symbol_to_num( 'Tc' ))
    assert_equal( 44, ELEM.symbol_to_num( 'Ru' ))
    assert_equal( 45, ELEM.symbol_to_num( 'Rh' ))
    assert_equal( 46, ELEM.symbol_to_num( 'Pd' ))
    assert_equal( 47, ELEM.symbol_to_num( 'Ag' ))
    assert_equal( 48, ELEM.symbol_to_num( 'Cd' ))
    assert_equal( 49, ELEM.symbol_to_num( 'In' ))
    assert_equal( 50, ELEM.symbol_to_num( 'Sn' ))
    assert_equal( 51, ELEM.symbol_to_num( 'Sb' ))
    assert_equal( 52, ELEM.symbol_to_num( 'Te' ))
    assert_equal( 53, ELEM.symbol_to_num( 'I'  ))
    assert_equal( 54, ELEM.symbol_to_num( 'Xe' ))
    assert_equal( 55, ELEM.symbol_to_num( 'Cs' ))
    assert_equal( 56, ELEM.symbol_to_num( 'Ba' ))
    assert_equal( 57, ELEM.symbol_to_num( 'La' ))
    assert_equal( 58, ELEM.symbol_to_num( 'Ce' ))
    assert_equal( 59, ELEM.symbol_to_num( 'Pr' ))
    assert_equal( 60, ELEM.symbol_to_num( 'Nd' ))
    assert_equal( 61, ELEM.symbol_to_num( 'Pm' ))
    assert_equal( 62, ELEM.symbol_to_num( 'Sm' ))
    assert_equal( 63, ELEM.symbol_to_num( 'Eu' ))
    assert_equal( 64, ELEM.symbol_to_num( 'Gd' ))
    assert_equal( 65, ELEM.symbol_to_num( 'Tb' ))
    assert_equal( 66, ELEM.symbol_to_num( 'Dy' ))
    assert_equal( 67, ELEM.symbol_to_num( 'Ho' ))
    assert_equal( 68, ELEM.symbol_to_num( 'Er' ))
    assert_equal( 69, ELEM.symbol_to_num( 'Tm' ))
    assert_equal( 70, ELEM.symbol_to_num( 'Yb' ))
    assert_equal( 71, ELEM.symbol_to_num( 'Lu' ))
    assert_equal( 72, ELEM.symbol_to_num( 'Hf' ))
    assert_equal( 73, ELEM.symbol_to_num( 'Ta' ))
    assert_equal( 74, ELEM.symbol_to_num( 'W'  ))
    assert_equal( 75, ELEM.symbol_to_num( 'Re' ))
    assert_equal( 76, ELEM.symbol_to_num( 'Os' ))
    assert_equal( 77, ELEM.symbol_to_num( 'Ir' ))
    assert_equal( 78, ELEM.symbol_to_num( 'Pt' ))
    assert_equal( 79, ELEM.symbol_to_num( 'Au' ))
    assert_equal( 80, ELEM.symbol_to_num( 'Hg' ))
    assert_equal( 81, ELEM.symbol_to_num( 'Tl' ))
    assert_equal( 82, ELEM.symbol_to_num( 'Pb' ))
    assert_equal( 83, ELEM.symbol_to_num( 'Bi' ))
    assert_equal( 84, ELEM.symbol_to_num( 'Po' ))
    assert_equal( 85, ELEM.symbol_to_num( 'At' ))
    assert_equal( 86, ELEM.symbol_to_num( 'Rn' ))
    assert_equal( 87, ELEM.symbol_to_num( 'Fr' ))
    assert_equal( 88, ELEM.symbol_to_num( 'Ra' ))
    assert_equal( 89, ELEM.symbol_to_num( 'Ac' ))
    assert_equal( 90, ELEM.symbol_to_num( 'Th' ))
    assert_equal( 91, ELEM.symbol_to_num( 'Pa' ))
    assert_equal( 92, ELEM.symbol_to_num( 'U'  ))
    assert_equal( 93, ELEM.symbol_to_num( 'Np' ))
    assert_equal( 94, ELEM.symbol_to_num( 'Pu' ))
    assert_equal( 95, ELEM.symbol_to_num( 'Am' ))
    assert_equal( 96, ELEM.symbol_to_num( 'Cm' ))
    assert_equal( 97, ELEM.symbol_to_num( 'Bk' ))
    assert_equal( 98, ELEM.symbol_to_num( 'Cf' ))
    assert_equal( 99, ELEM.symbol_to_num( 'Es' ))
    assert_equal(100, ELEM.symbol_to_num( 'Fm' ))
    assert_equal(101, ELEM.symbol_to_num( 'Md' ))
    assert_equal(102, ELEM.symbol_to_num( 'No' ))
    assert_equal(103, ELEM.symbol_to_num( 'Lr' ))

    assert_raise(ELEM::NotExistError){ ELEM.symbol_to_num( 10 )}
    assert_raise(ELEM::NotExistError){ ELEM.symbol_to_num( 104 )}
    assert_raise(ELEM::NotExistError){ ELEM.symbol_to_num( 'A' )}
    assert_raise(ELEM::NotExistError){ ELEM.symbol_to_num( nil )}
  end

  def test_symbol
    assert_equal('H' , ELEM.num_to_symbol(     1 ))
    assert_equal('He', ELEM.num_to_symbol(     2 ))
    assert_equal('Li', ELEM.num_to_symbol(     3 ))
    assert_equal('Be', ELEM.num_to_symbol(     4 ))
    assert_equal('B' , ELEM.num_to_symbol(     5 ))
    assert_equal('C' , ELEM.num_to_symbol(     6 ))
    assert_equal('N' , ELEM.num_to_symbol(     7 ))
    assert_equal('O' , ELEM.num_to_symbol(     8 ))
    assert_equal('F' , ELEM.num_to_symbol(     9 ))
    assert_equal('Ne', ELEM.num_to_symbol(    10 ))
    assert_equal('Na', ELEM.num_to_symbol(    11 ))
    assert_equal('Mg', ELEM.num_to_symbol(    12 ))
    assert_equal('Al', ELEM.num_to_symbol(    13 ))
    assert_equal('Si', ELEM.num_to_symbol(    14 ))
    assert_equal('P' , ELEM.num_to_symbol(    15 ))
    assert_equal('S' , ELEM.num_to_symbol(    16 ))
    assert_equal('Cl', ELEM.num_to_symbol(    17 ))
    assert_equal('Ar', ELEM.num_to_symbol(    18 ))
    assert_equal('K' , ELEM.num_to_symbol(    19 ))
    assert_equal('Ca', ELEM.num_to_symbol(    20 ))
    assert_equal('Sc', ELEM.num_to_symbol(    21 ))
    assert_equal('Ti', ELEM.num_to_symbol(    22 ))
    assert_equal('V' , ELEM.num_to_symbol(    23 ))
    assert_equal('Cr', ELEM.num_to_symbol(    24 ))
    assert_equal('Mn', ELEM.num_to_symbol(    25 ))
    assert_equal('Fe', ELEM.num_to_symbol(    26 ))
    assert_equal('Co', ELEM.num_to_symbol(    27 ))
    assert_equal('Ni', ELEM.num_to_symbol(    28 ))
    assert_equal('Cu', ELEM.num_to_symbol(    29 ))
    assert_equal('Zn', ELEM.num_to_symbol(    30 ))
    assert_equal('Ga', ELEM.num_to_symbol(    31 ))
    assert_equal('Ge', ELEM.num_to_symbol(    32 ))
    assert_equal('As', ELEM.num_to_symbol(    33 ))
    assert_equal('Se', ELEM.num_to_symbol(    34 ))
    assert_equal('Br', ELEM.num_to_symbol(    35 ))
    assert_equal('Kr', ELEM.num_to_symbol(    36 ))
    assert_equal('Rb', ELEM.num_to_symbol(    37 ))
    assert_equal('Sr', ELEM.num_to_symbol(    38 ))
    assert_equal('Y' , ELEM.num_to_symbol(    39 ))
    assert_equal('Zr', ELEM.num_to_symbol(    40 ))
    assert_equal('Nb', ELEM.num_to_symbol(    41 ))
    assert_equal('Mo', ELEM.num_to_symbol(    42 ))
    assert_equal('Tc', ELEM.num_to_symbol(    43 ))
    assert_equal('Ru', ELEM.num_to_symbol(    44 ))
    assert_equal('Rh', ELEM.num_to_symbol(    45 ))
    assert_equal('Pd', ELEM.num_to_symbol(    46 ))
    assert_equal('Ag', ELEM.num_to_symbol(    47 ))
    assert_equal('Cd', ELEM.num_to_symbol(    48 ))
    assert_equal('In', ELEM.num_to_symbol(    49 ))
    assert_equal('Sn', ELEM.num_to_symbol(    50 ))
    assert_equal('Sb', ELEM.num_to_symbol(    51 ))
    assert_equal('Te', ELEM.num_to_symbol(    52 ))
    assert_equal('I' , ELEM.num_to_symbol(    53 ))
    assert_equal('Xe', ELEM.num_to_symbol(    54 ))
    assert_equal('Cs', ELEM.num_to_symbol(    55 ))
    assert_equal('Ba', ELEM.num_to_symbol(    56 ))
    assert_equal('La', ELEM.num_to_symbol(    57 ))
    assert_equal('Ce', ELEM.num_to_symbol(    58 ))
    assert_equal('Pr', ELEM.num_to_symbol(    59 ))
    assert_equal('Nd', ELEM.num_to_symbol(    60 ))
    assert_equal('Pm', ELEM.num_to_symbol(    61 ))
    assert_equal('Sm', ELEM.num_to_symbol(    62 ))
    assert_equal('Eu', ELEM.num_to_symbol(    63 ))
    assert_equal('Gd', ELEM.num_to_symbol(    64 ))
    assert_equal('Tb', ELEM.num_to_symbol(    65 ))
    assert_equal('Dy', ELEM.num_to_symbol(    66 ))
    assert_equal('Ho', ELEM.num_to_symbol(    67 ))
    assert_equal('Er', ELEM.num_to_symbol(    68 ))
    assert_equal('Tm', ELEM.num_to_symbol(    69 ))
    assert_equal('Yb', ELEM.num_to_symbol(    70 ))
    assert_equal('Lu', ELEM.num_to_symbol(    71 ))
    assert_equal('Hf', ELEM.num_to_symbol(    72 ))
    assert_equal('Ta', ELEM.num_to_symbol(    73 ))
    assert_equal('W' , ELEM.num_to_symbol(    74 ))
    assert_equal('Re', ELEM.num_to_symbol(    75 ))
    assert_equal('Os', ELEM.num_to_symbol(    76 ))
    assert_equal('Ir', ELEM.num_to_symbol(    77 ))
    assert_equal('Pt', ELEM.num_to_symbol(    78 ))
    assert_equal('Au', ELEM.num_to_symbol(    79 ))
    assert_equal('Hg', ELEM.num_to_symbol(    80 ))
    assert_equal('Tl', ELEM.num_to_symbol(    81 ))
    assert_equal('Pb', ELEM.num_to_symbol(    82 ))
    assert_equal('Bi', ELEM.num_to_symbol(    83 ))
    assert_equal('Po', ELEM.num_to_symbol(    84 ))
    assert_equal('At', ELEM.num_to_symbol(    85 ))
    assert_equal('Rn', ELEM.num_to_symbol(    86 ))
    assert_equal('Fr', ELEM.num_to_symbol(    87 ))
    assert_equal('Ra', ELEM.num_to_symbol(    88 ))
    assert_equal('Ac', ELEM.num_to_symbol(    89 ))
    assert_equal('Th', ELEM.num_to_symbol(    90 ))
    assert_equal('Pa', ELEM.num_to_symbol(    91 ))
    assert_equal('U' , ELEM.num_to_symbol(    92 ))
    assert_equal('Np', ELEM.num_to_symbol(    93 ))
    assert_equal('Pu', ELEM.num_to_symbol(    94 ))
    assert_equal('Am', ELEM.num_to_symbol(    95 ))
    assert_equal('Cm', ELEM.num_to_symbol(    96 ))
    assert_equal('Bk', ELEM.num_to_symbol(    97 ))
    assert_equal('Cf', ELEM.num_to_symbol(    98 ))
    assert_equal('Es', ELEM.num_to_symbol(    99 ))
    assert_equal('Fm', ELEM.num_to_symbol( 100 ))
    assert_equal('Md', ELEM.num_to_symbol( 101 ))
    assert_equal('No', ELEM.num_to_symbol( 102 ))
    assert_equal('Lr', ELEM.num_to_symbol( 103 ))

    assert_raise(ELEM::NotExistError){ELEM.num_to_symbol( 'H'  )}
    assert_raise(ELEM::NotExistError){ELEM.num_to_symbol( 'Na' )}
    assert_raise(ELEM::NotExistError){ELEM.num_to_symbol( nil  )}
    assert_raise(ELEM::NotExistError){ELEM.num_to_symbol( 'A'  )}
    assert_raise(ELEM::NotExistError){ELEM.num_to_symbol( -1   )}
    assert_raise(ELEM::NotExistError){ELEM.num_to_symbol(  0   )}
    assert_raise(ELEM::NotExistError){ELEM.num_to_symbol( 104  )}
  end

  def test_atomic_radius
    assert_equal(0.53, ELEM.atomic_radius(1 ))
    assert_equal(0.31, ELEM.atomic_radius(2 ))
    assert_equal(1.67, ELEM.atomic_radius(3 ))
    assert_equal(1.12, ELEM.atomic_radius(4 ))
    assert_equal(0.87, ELEM.atomic_radius(5 ))
    assert_equal(0.67, ELEM.atomic_radius(6 ))
    assert_equal(0.56, ELEM.atomic_radius(7 ))
    assert_equal(0.48, ELEM.atomic_radius(8 ))
    assert_equal(0.42, ELEM.atomic_radius(9 ))
    assert_equal(0.38, ELEM.atomic_radius(10))
    assert_equal(1.90, ELEM.atomic_radius(11))
    assert_equal(1.45, ELEM.atomic_radius(12))
    assert_equal(1.18, ELEM.atomic_radius(13))
    assert_equal(1.11, ELEM.atomic_radius(14))
    assert_equal(0.98, ELEM.atomic_radius(15))
    assert_equal(0.88, ELEM.atomic_radius(16))
    assert_equal(0.79, ELEM.atomic_radius(17))
    assert_equal(0.71, ELEM.atomic_radius(18))
    assert_equal(2.43, ELEM.atomic_radius(19))
    assert_equal(1.94, ELEM.atomic_radius(20))
    assert_equal(1.84, ELEM.atomic_radius(21))
    assert_equal(1.76, ELEM.atomic_radius(22))
    assert_equal(1.71, ELEM.atomic_radius(23))
    assert_equal(1.66, ELEM.atomic_radius(24))
    assert_equal(1.61, ELEM.atomic_radius(25))
    assert_equal(1.56, ELEM.atomic_radius(26))
    assert_equal(1.52, ELEM.atomic_radius(27))
    assert_equal(1.49, ELEM.atomic_radius(28))
    assert_equal(1.45, ELEM.atomic_radius(29))
    assert_equal(1.42, ELEM.atomic_radius(30))
    assert_equal(1.36, ELEM.atomic_radius(31))
    assert_equal(1.25, ELEM.atomic_radius(32))
    assert_equal(1.14, ELEM.atomic_radius(33))
    assert_equal(1.03, ELEM.atomic_radius(34))
    assert_equal(0.94, ELEM.atomic_radius(35))
    assert_equal(0.88, ELEM.atomic_radius(36))
    assert_equal(2.65, ELEM.atomic_radius(37))
    assert_equal(2.19, ELEM.atomic_radius(38))
    assert_equal(2.12, ELEM.atomic_radius(39))
    assert_equal(2.06, ELEM.atomic_radius(40))
    assert_equal(1.98, ELEM.atomic_radius(41))
    assert_equal(1.90, ELEM.atomic_radius(42))
    assert_equal(1.83, ELEM.atomic_radius(43))
    assert_equal(1.78, ELEM.atomic_radius(44))
    assert_equal(1.73, ELEM.atomic_radius(45))
    assert_equal(1.69, ELEM.atomic_radius(46))
    assert_equal(1.65, ELEM.atomic_radius(47))
    assert_equal(1.61, ELEM.atomic_radius(48))
    assert_equal(1.56, ELEM.atomic_radius(49))
    assert_equal(1.45, ELEM.atomic_radius(50))
    assert_equal(1.33, ELEM.atomic_radius(51))
    assert_equal(1.23, ELEM.atomic_radius(52))
    assert_equal(1.15, ELEM.atomic_radius(53))
    assert_equal(1.08, ELEM.atomic_radius(54))
    assert_equal(2.98, ELEM.atomic_radius(55))
    assert_equal(2.53, ELEM.atomic_radius(56))
    assert_equal(1.95, ELEM.atomic_radius(57))
    assert_equal(1.85, ELEM.atomic_radius(58))
    assert_equal(2.47, ELEM.atomic_radius(59))
    assert_equal(2.06, ELEM.atomic_radius(60))
    assert_equal(2.05, ELEM.atomic_radius(61))
    assert_equal(2.38, ELEM.atomic_radius(62))
    assert_equal(2.31, ELEM.atomic_radius(63))
    assert_equal(2.33, ELEM.atomic_radius(64))
    assert_equal(2.25, ELEM.atomic_radius(65))
    assert_equal(2.28, ELEM.atomic_radius(66))
    assert_equal(2.26, ELEM.atomic_radius(67))
    assert_equal(2.26, ELEM.atomic_radius(68))
    assert_equal(2.22, ELEM.atomic_radius(69))
    assert_equal(2.22, ELEM.atomic_radius(70))
    assert_equal(2.17, ELEM.atomic_radius(71))
    assert_equal(2.08, ELEM.atomic_radius(72))
    assert_equal(2.00, ELEM.atomic_radius(73))
    assert_equal(1.93, ELEM.atomic_radius(74))
    assert_equal(1.88, ELEM.atomic_radius(75))
    assert_equal(1.85, ELEM.atomic_radius(76))
    assert_equal(1.80, ELEM.atomic_radius(77))
    assert_equal(1.77, ELEM.atomic_radius(78))
    assert_equal(1.74, ELEM.atomic_radius(79))
    assert_equal(1.71, ELEM.atomic_radius(80))
    assert_equal(1.56, ELEM.atomic_radius(81))
    assert_equal(1.54, ELEM.atomic_radius(82))
    assert_equal(1.43, ELEM.atomic_radius(83))
    assert_equal(1.35, ELEM.atomic_radius(84))
    assert_equal(1.27, ELEM.atomic_radius(85))
    assert_equal(1.20, ELEM.atomic_radius(86))
    assert_equal(nil , ELEM.atomic_radius(87))
    assert_equal(nil , ELEM.atomic_radius(88))
    assert_equal(1.95, ELEM.atomic_radius(89))
    assert_equal(1.80, ELEM.atomic_radius(90))
    assert_equal(1.80, ELEM.atomic_radius(91))
    assert_equal(1.75, ELEM.atomic_radius(92))
    assert_equal(1.75, ELEM.atomic_radius(93))
    assert_equal(1.75, ELEM.atomic_radius(94))
    assert_equal(1.75, ELEM.atomic_radius(95))
    assert_equal(nil , ELEM.atomic_radius(96))

    assert_equal(0.53, ELEM.atomic_radius('H' ))
    assert_equal(0.31, ELEM.atomic_radius('He'))
    assert_equal(1.67, ELEM.atomic_radius('Li'))
    assert_equal(1.12, ELEM.atomic_radius('Be'))
    assert_equal(0.87, ELEM.atomic_radius('B' ))
    assert_equal(0.67, ELEM.atomic_radius('C' ))
    assert_equal(0.56, ELEM.atomic_radius('N' ))
    assert_equal(0.48, ELEM.atomic_radius('O' ))
    assert_equal(0.42, ELEM.atomic_radius('F' ))
    assert_equal(0.38, ELEM.atomic_radius('Ne'))
    assert_equal(1.90, ELEM.atomic_radius('Na'))
    assert_equal(1.45, ELEM.atomic_radius('Mg'))
    assert_equal(1.18, ELEM.atomic_radius('Al'))
    assert_equal(1.11, ELEM.atomic_radius('Si'))
    assert_equal(0.98, ELEM.atomic_radius('P' ))
    assert_equal(0.88, ELEM.atomic_radius('S' ))
    assert_equal(0.79, ELEM.atomic_radius('Cl'))
    assert_equal(0.71, ELEM.atomic_radius('Ar'))
    assert_equal(2.43, ELEM.atomic_radius('K' ))
    assert_equal(1.94, ELEM.atomic_radius('Ca'))
    assert_equal(1.84, ELEM.atomic_radius('Sc'))
    assert_equal(1.76, ELEM.atomic_radius('Ti'))
    assert_equal(1.71, ELEM.atomic_radius('V' ))
    assert_equal(1.66, ELEM.atomic_radius('Cr'))
    assert_equal(1.61, ELEM.atomic_radius('Mn'))
    assert_equal(1.56, ELEM.atomic_radius('Fe'))
    assert_equal(1.52, ELEM.atomic_radius('Co'))
    assert_equal(1.49, ELEM.atomic_radius('Ni'))
    assert_equal(1.45, ELEM.atomic_radius('Cu'))
    assert_equal(1.42, ELEM.atomic_radius('Zn'))
    assert_equal(1.36, ELEM.atomic_radius('Ga'))
    assert_equal(1.25, ELEM.atomic_radius('Ge'))
    assert_equal(1.14, ELEM.atomic_radius('As'))
    assert_equal(1.03, ELEM.atomic_radius('Se'))
    assert_equal(0.94, ELEM.atomic_radius('Br'))
    assert_equal(0.88, ELEM.atomic_radius('Kr'))
    assert_equal(2.65, ELEM.atomic_radius('Rb'))
    assert_equal(2.19, ELEM.atomic_radius('Sr'))
    assert_equal(2.12, ELEM.atomic_radius('Y' ))
    assert_equal(2.06, ELEM.atomic_radius('Zr'))
    assert_equal(1.98, ELEM.atomic_radius('Nb'))
    assert_equal(1.90, ELEM.atomic_radius('Mo'))
    assert_equal(1.83, ELEM.atomic_radius('Tc'))
    assert_equal(1.78, ELEM.atomic_radius('Ru'))
    assert_equal(1.73, ELEM.atomic_radius('Rh'))
    assert_equal(1.69, ELEM.atomic_radius('Pd'))
    assert_equal(1.65, ELEM.atomic_radius('Ag'))
    assert_equal(1.61, ELEM.atomic_radius('Cd'))
    assert_equal(1.56, ELEM.atomic_radius('In'))
    assert_equal(1.45, ELEM.atomic_radius('Sn'))
    assert_equal(1.33, ELEM.atomic_radius('Sb'))
    assert_equal(1.23, ELEM.atomic_radius('Te'))
    assert_equal(1.15, ELEM.atomic_radius('I' ))
    assert_equal(1.08, ELEM.atomic_radius('Xe'))
    assert_equal(2.98, ELEM.atomic_radius('Cs'))
    assert_equal(2.53, ELEM.atomic_radius('Ba'))
    assert_equal(1.95, ELEM.atomic_radius('La'))
    assert_equal(1.85, ELEM.atomic_radius('Ce'))
    assert_equal(2.47, ELEM.atomic_radius('Pr'))
    assert_equal(2.06, ELEM.atomic_radius('Nd'))
    assert_equal(2.05, ELEM.atomic_radius('Pm'))
    assert_equal(2.38, ELEM.atomic_radius('Sm'))
    assert_equal(2.31, ELEM.atomic_radius('Eu'))
    assert_equal(2.33, ELEM.atomic_radius('Gd'))
    assert_equal(2.25, ELEM.atomic_radius('Tb'))
    assert_equal(2.28, ELEM.atomic_radius('Dy'))
    assert_equal(2.26, ELEM.atomic_radius('Ho'))
    assert_equal(2.26, ELEM.atomic_radius('Er'))
    assert_equal(2.22, ELEM.atomic_radius('Tm'))
    assert_equal(2.22, ELEM.atomic_radius('Yb'))
    assert_equal(2.17, ELEM.atomic_radius('Lu'))
    assert_equal(2.08, ELEM.atomic_radius('Hf'))
    assert_equal(2.00, ELEM.atomic_radius('Ta'))
    assert_equal(1.93, ELEM.atomic_radius('W' ))
    assert_equal(1.88, ELEM.atomic_radius('Re'))
    assert_equal(1.85, ELEM.atomic_radius('Os'))
    assert_equal(1.80, ELEM.atomic_radius('Ir'))
    assert_equal(1.77, ELEM.atomic_radius('Pt'))
    assert_equal(1.74, ELEM.atomic_radius('Au'))
    assert_equal(1.71, ELEM.atomic_radius('Hg'))
    assert_equal(1.56, ELEM.atomic_radius('Tl'))
    assert_equal(1.54, ELEM.atomic_radius('Pb'))
    assert_equal(1.43, ELEM.atomic_radius('Bi'))
    assert_equal(1.35, ELEM.atomic_radius('Po'))
    assert_equal(1.27, ELEM.atomic_radius('At'))
    assert_equal(1.20, ELEM.atomic_radius('Rn'))
    assert_equal(nil , ELEM.atomic_radius('Fr'))
    assert_equal(nil , ELEM.atomic_radius('Ra'))
    assert_equal(1.95, ELEM.atomic_radius('Ac'))
    assert_equal(1.80, ELEM.atomic_radius('Th'))
    assert_equal(1.80, ELEM.atomic_radius('Pa'))
    assert_equal(1.75, ELEM.atomic_radius('U' ))
    assert_equal(1.75, ELEM.atomic_radius('Np'))
    assert_equal(1.75, ELEM.atomic_radius('Pu'))
    assert_equal(1.75, ELEM.atomic_radius('Am'))
    assert_equal(nil , ELEM.atomic_radius('Cm'))
  end
end

